<template>
    <div class="box">
        <div class="is-grouped is-grouped-multiline field">
           <div v-for="(tag, index) in chosenTags" class="control add-small-bottom-space">
                <div class="tags has-addons">
                    <span class="tag is-sidebar">{{ tag.filterLabel }}</span>
                    <span class="tag is-primary">{{ tag.valueLabel }}</span>
                    <span class="tag is-delete" @click="remove(index)"></span>
                </div>
            </div>
        </div>

        <div class="field has-addons">
            <p class="control">
                <span class="select">
                    <select v-model="chosenFilter">
                        <option v-for="filter in filters" :disabled="isChosen(filter.value)" :value="filter.value">{{ filter.label }}</option>
                    </select>
                </span>
            </p>
            <b-auto-complete
                class="is-expanded"
                v-model="text"
                placeholder="Start Typing Filter"
                :data="options"
                :keep-first="false"
                field="label"
                @input="updateOptions"
                @select="selected"
            ></b-auto-complete>
            <p class="control">
                <button class="button" :class="{'is-loading': loading}" @click="afterFilter(returnFilters)">Filter</button>
            </p>
        </div>
    </div>
</template>

<script>
    import debounce from 'lodash/debounce';
    import BAutoComplete from '../../../../../node_modules/buefy/src/components/autocomplete/Autocomplete.vue';

    export default {
        props:{
            filters: Array,
            afterFilter: Function
        },
        components: {BAutoComplete},
        data() {
            return {
                text: null,
                options:[],
                chosenTags: [],
                chosenFilter: this.filters[0].value,
                loading: false
            }
        },
        computed: {
            chosen() {
                return this.chosenTags.map(tag => tag.filterProp);
            },
            returnFilters() {
                return this.chosenTags.reduce((carry, tag) => {
                        carry[tag.filterProp] = tag.valueId;
                        return carry;
                    }, {}
                );
            }
        },
        methods: {
            findOptions: debounce(function() {
                if(!this.text) return;

                this.loading = true;

                this.filters
                .find((filter) => filter.value === this.chosenFilter)
                .options(this.text)
                .then((data) => {
                     this.options = data;
                     this.loading = false;
                 })
            }, 300),
            updateOptions() {
                this.findOptions();
            },
            isChosen(value) {
                return this.chosen.indexOf(value) !== -1;
            },
            addTag(filter, select) {
                this.chosenTags.push({
                    filterLabel: filter.label,
                    filterProp: filter.value,
                    valueId: select.id || select.value,
                    valueLabel: select.label
                });
            },
            selected(select) {
                if(!select) return;

                let filter = this.filters.find((tag) => tag.value === this.chosenFilter);

                this.addTag(filter, select);

                if(this.chosenTags.length < this.filters.length) {
                    this.chosenFilter = this.filters.find((filter) => !this.isChosen(filter.value)).value;
                }

                this.clearSelections();
            },
            clearSelections: debounce(function() {
                this.options = [];
                this.text = null;
            }, 100),
            remove(index) {
                this.chosenTags.splice(index, 1);
            }
        },
        watch: {
            'chosenFilter' (from, to) {
                this.clearSelections();
            }
        },
        created() {
            this.filters.forEach((filter) => {
                if(filter.hasOwnProperty('initial')) {
                    filter.initial.then((response) => {
                       this.addTag(filter, response);
                    });
                }
            });
        }
    }
</script>